my.isDev = true;
function jump(item, position) {
    !item && alert("组件jump函数，跳转对象错误!");
    position === undefined && alert("组件坑位不能为空");
}
function moredata() {
    console.log("加载更多", this);
}
my.instance = new Vue({
    data() {
        return {
            name: null,
            data: null,
            meta: null,
        };
    },
    provide: {
        jump: jump,
        moredata: moredata,
    },
    created() {
        Vue.use(vant.Lazyload);
        // 添加组件切换监听
        my.on("setComponent", (name) => {
            return fetch("/" + name + ".json")
                .then((response) => {
                    return response.json();
                })
                .then((body) => {
                    this.data = body.mock;
                    let meta = {};
                    body.meta.forEach(
                        (item) => (meta[item.name] = item["default"])
                    );
                    this.meta = meta;
                    this.name = body.module + "-" + name;
                })
                .catch((err) => {
                    throw err;
                });
        });
        let hash = window.location.hash;
        if (hash) {
            hash = hash.substr(1);
            load(hash);
        }
        // 加载所有组件
        fetch("/components")
            .then((response) => {
                return response.json();
            })
            .then((result) => {
                let navi = document.getElementById("J_navi"),
                    content = "";
                result.data.forEach(
                    (item) =>
                        (content += `<span onclick="select('${item}')">${item}</span>`)
                );
                navi.innerHTML = content;
            })
            .catch((err) => {
                throw err;
            });
    },
    render(h) {
        if (this.name === null) {
            return h("van-empty", { props: { description: "请选择组件" } });
        }
        return h(this.name, {
            attrs: { spm: this.name },
            props: { value: this.data, meta: this.meta, key: this.name },
        });
    },
}).$mount("#J_app");

// 下载组件，再更新渲染
function load(name) {
    window.location.hash = name;
    my.emit("setComponent", name);
    // let res = name + ".js";
    // my.load([res], () => my.emit("setComponent", name));
    my.tracker.enter(name);
}
// 全局组件切换换上
window.select = function (name) {
    load(name);
};
