/**
 *@description 向oss打包发布文件
 */
const os = require("os");
let domain = "${domain}";
const config = {
    bucket: "${bucket}",
    accessKeyId: "${accessKeyId}",
    accessKeySecret: "${accessKeySecret}"
};
const simpleGit = require("simple-git");
const GIT = simpleGit("./");
const fs = require("fs");
const { join, sep } = require("path");
const packageFile = JSON.parse(fs.readFileSync("./package.json"));
const OSS = require("ali-oss");
const client = new OSS(config);
function send(dir, output) {
    let files = fs.readdirSync(dir);
    files.forEach((item, index) => {
        // 过滤无效文件
        if (item.indexOf(".") === 0 || item.indexOf(".html") > -1) {
            return;
        }
        let fPath = join(dir, item);
        let stat = fs.statSync(fPath);
        if (stat.isDirectory() === true) {
            send(fPath, join(output, item));
        }
        if (stat.isFile() === true) {
            console.log(fPath);
            let target = join(output, item)
                .split(sep)
                .join("/");
            client.put(target, fPath);
        }
    });
}
GIT.branchLocal((err, branch) => {
    let name = packageFile.name,
        version = branch.current;
    send(join(__dirname, "../dist"), name + "/" + version + "/");
    console.log(domain + "/" + name + "/" + version + "/js/app.js");
});
